RollMaster = LibStub("AceAddon-3.0"):NewAddon("RollMaster", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("RollMaster")


--FUCK! so many variables.... Should put them into a table: local RollMasterVars = {} instead of this.... (O_O)
local lastTime	-- the variable for onupdate function... 

-- Button counters
local NUM_BUTTONS = 0	
local NUM_ITEMBUTTONS = 0

-- Button size
local BUTTON_HEIGHT = 18	
local BUTTON_WIDTH = 195	

-- Roll storage
local RollMaster_RollCollector = {}	-- here be rolls stored!
local highestRoller = {}	
local highestRoll = 0		
local alreadyRolled = {}

-- Item storage
local nextItem	
local itemsForRoll = {}
		
-- Buttons to show items and rolls
	-- "roll" list
local buttons = {}		
	-- tables for SetText()
	local roleTextures = {} 
	local names = {}			
	local rolls = {}		
	-- "item" list
local itemButtons = {}	
	local items = {} -- the item links for font strings

-- Timer variables
local startTimer			
local rollStarted			
local three = false		
local two = false		
local one = false	

-- Chat method ("PARTY", "RAID", "RAID_WARNING"		
local chatMethod

-- Winner storage (the addon always gives loot to "highestRoller" if no "Winner" is selected. Select a winner in the roll-menu.
local Winner		

-- When 2 or more people roll "highestRoll", the names of the two will be stored as "rerollCandidates" when pressing the "Reroll" button, only names that match those in this list, will have their rolls collected.		
local rerollCandidates = {}
-- When putting an item as "nextItem", the names of those eligible for it will be stored in this variable (to prevent addon trying to "award" the loot to a person, that is not eligible.
local lootCandidates = {}

----------------------------------------------------------------------------------

-- OnEnable
function RollMaster:OnEnable()
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("LOOT_OPENED")
	self:RegisterEvent("LOOT_CLOSED")
	lastTime = GetTime()
end

--Debug!
local function d(msg)
	print(msg)
end

-- Function to clear all roll-buttons.
local function button_clear()
	for i = 1, NUM_BUTTONS do
		buttons[i]:ClearAllPoints()
		buttons[i]:Hide()
	end
	NUM_BUTTONS = 0
	table.wipe(RollMaster_RollCollector)
	table.wipe(buttons)
	table.wipe(names)
	table.wipe(rolls)
	table.wipe(lootCandidates)
	table.wipe(alreadyRolled)
	table.wipe(highestRoller)
	highestRoll = 0
	table.wipe(rerollCandidates)
	RollMaster_RollFrame:SetHeight(20)
end

--Main body frame. Contains the onupdate function, aswell as being the parent of all other frames.
local RollMaster_TopFrame = CreateFrame("Frame", "RollMaster_TopFrame", UIParent)
	RollMaster_TopFrame:SetWidth(200)	
	RollMaster_TopFrame:SetHeight(80)
	RollMaster_TopFrame:SetPoint("CENTER", UIParent)
	RollMaster_TopFrame:RegisterForDrag("LeftButton")	
	RollMaster_TopFrame:EnableMouse(true)
	RollMaster_TopFrame:SetMovable(true)
	RollMaster_TopFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	RollMaster_TopFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

	RollMaster_TopFrame_Texture = RollMaster_TopFrame:CreateTexture()
	RollMaster_TopFrame_Texture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_TopFrame_Texture:SetAllPoints(RollMaster_TopFrame)

	
local f = CreateFrame("Frame")	
f:SetScript("OnUpdate", function()
	if GetTime() - lastTime >= 0.2 then
		lastTime = GetTime()
		if rollStarted then
			if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
				chatMethod = "RAID_WARNING"
			elseif IsInRaid() then
				chatMethod = "RAID"
			else
				chatMethod = "PARTY"
			end
			if GetTime() - startTimer >= 10 then 
					SendChatMessage(L["Rolls for"] .. " " .. nextItem .." " .. L["has ended!"], chatMethod)
				if table.getn(highestRoller) >= 2 then
					RollMaster_StartRollText:SetText("|cffffffff" .. L["Reroll"])
					RollMaster_Award:Show()
					table.getn(highestRoller)
					table.wipe(rerollCandidates)
					rerollCandidates = highestRoller
				elseif RollMaster_StartRollText:GetText() == "|cffffffff" .. L["Offspec"] then
					RollMaster_StartRollText:SetText("|cffffffff" .. L["Raid Roll!"])
					if highestRoller[1] then
						RollMaster_Award:Show()
					end
				elseif RollMaster_StartRollText:GetText() == "|cffffffff" .. L["Start Rolls!"] then
					RollMaster_StartRollText:SetText("|cffffffff" .. L["Offspec"])
					if highestRoller[1] then
						RollMaster_Award:Show()
					end
				end
				startTimer = 0
				rollStarted = false
				one = false
				two = false
				three = false
			
			elseif GetTime() - startTimer >= 9 and not one and rollStarted then 
				SendChatMessage(L["Roll"] .. ": " .. nextItem .." - " .. L["1 second left!"], chatMethod)
				one = true
			elseif GetTime() - startTimer >= 8 and not two and rollStarted then 
				SendChatMessage(L["Roll"] .. ": " .. nextItem .." - " .. L["2 seconds left!"], chatMethod)
				two = true
			elseif GetTime() - startTimer >= 7 and not three and rollStarted then 
				SendChatMessage(L["Roll"] .. ": " .. nextItem .." - " .. L["3 seconds left!"], chatMethod)
				three = true
			end
		end
	end
end)


--Item icon button and tooltip creator
local function OnEnter(self)
	if nextItem then
	  GameTooltip:SetOwner(self)
	  GameTooltip:SetPoint("LEFT", RollMaster_Item, "RIGHT")
	  GameTooltip:SetHyperlink(nextItem)
	  GameTooltip:Show()
	end
end	
local function OnLeave(self)
  GameTooltip:Hide()
end
local RollMaster_Item = CreateFrame("Button", "RollMaster_Item", RollMaster_TopFrame)
	RollMaster_Item:SetPoint("TOPLEFT", RollMaster_TopFrame, "TOPLEFT", 5, -5)
	RollMaster_Item:SetSize(50, 50)
	RollMaster_Item:SetScript("OnEnter", OnEnter)
	RollMaster_Item:SetScript("OnLeave", OnLeave)
	RollMaster_Item:SetNormalTexture("Interface\\BUTTONS\\UI-EmptySlot")
	
-- "Start Roll!" button.
local RollMaster_StartRoll = CreateFrame("Button", "RollMaster_StartRoll", RollMaster_TopFrame)
	RollMaster_StartRoll:SetPoint("TOPLEFT", RollMaster_Item, "TOPRIGHT", 5, -5)
	RollMaster_StartRoll:SetSize(80, 20)
	RollMaster_StartRoll:SetScript("OnClick", function()
																		if nextItem then	
																			RollMaster_Award:Hide()
																			if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																				chatMethod = "RAID_WARNING"
																			elseif IsInRaid() then
																				chatMethod = "RAID"
																			else
																				chatMethod = "PARTY"
																			end
																			if RollMaster_StartRollText:GetText() ~= "|cffffffff" .. L["Pick an Item!"] then 
																				if  RollMaster_StartRollText:GetText() == "|cffffffff" .. L["Raid Roll!"] then
																					local name
																					local index
																					local rollNum
																					for i = 1, GetNumLootItems() do
																						if nextItem == GetLootSlotLink(i) then
																							index = i
																						end
																					end
																					for i = 1, GetNumGroupMembers() do
																						if GetMasterLootCandidate(index, i) then 
																							local name = GetMasterLootCandidate(index, i)
																							if IsInRaid() then 
																								SendChatMessage(name.." = " ..i, "RAID")
																							else
																								SendChatMessage(name.." = " ..i, "PARTY")
																							end
																							rollNum = i
																						end
																					end
																					RandomRoll(1, rollNum)
																				elseif RollMaster_StartRollText:GetText() == ("|cffffffff" .. L["Reroll"]) then
																					SendChatMessage(L["Rerolls for"] .." " .. nextItem .. " " .. L["has started. Roll again if you rolled"] .. " " .. highestRoll .. "! "  ..L["You have 10 seconds to /roll!"], chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				elseif RollMaster_StartRollText:GetText() == "|cffffffff" .. L["Offspec"] then
																					SendChatMessage(L["Offspec rolls for"] .. " " .. nextItem .. " " .. L["has started! You have 10 seconds to /roll!"], chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				else
																					SendChatMessage(L["Mainspec rolls for"] .. " " .. nextItem .. " " .. L["has started! You have 10 seconds to /roll!"], chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				end	
																				button_clear()
																			end
																		end
																	end)
	local RollMaster_StartRollText = RollMaster_StartRoll:CreateFontString("RollMaster_StartRollText", nil, "GameFontNormal")
		RollMaster_StartRollText:SetText("|cffffffff" .. L["Pick an Item!"])
		RollMaster_StartRollText:SetPoint("CENTER")
	RollMaster_StartRoll:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_StartRoll:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")

--The frame to the right containing the item-buttons.
local RollMaster_ItemFrame = CreateFrame("Frame", "RollMaster_ItemFrame", RollMaster_TopFrame)
	RollMaster_ItemFrame:SetWidth(200)	
	RollMaster_ItemFrame:SetHeight(table.getn(itemsForRoll)*BUTTON_HEIGHT + 20)	
	RollMaster_ItemFrame:SetPoint("TOPLEFT", RollMaster_TopFrame, "TOPRIGHT")
	RollMaster_ItemFrame.texture = RollMaster_ItemFrame:CreateTexture()
	RollMaster_ItemFrame.texture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_ItemFrame.texture:SetAllPoints(RollMaster_ItemFrame)

--Container frame. Contains the "# name roll" buttons.
local RollMaster_RollFrame = CreateFrame("Frame", "RollMaster_RollFrame", RollMaster_TopFrame) --, "UIPanelDialogTemplate")
	RollMaster_RollFrame:SetWidth(200)
	RollMaster_RollFrame:SetHeight(20)
	RollMaster_RollFrame:SetPoint("TOP", RollMaster_TopFrame, "BOTTOM")
	RollMaster_RollFrame_RollTexture = RollMaster_RollFrame:CreateTexture()
	RollMaster_RollFrame_RollTexture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\GridFrame")
	RollMaster_RollFrame_RollTexture:SetAllPoints(RollMaster_RollFrame)

--Top line in the roll-frame - the base of the grid (info-line)
local RollMaster_TopButton = CreateFrame("Button", "RollMaster_TopButton", RollMaster_RollFrame)
	RollMaster_TopButton:SetPoint("TOP", RollMaster_RollFrame, "TOP", 0, -2)
	RollMaster_TopButton:SetSize(BUTTON_WIDTH, BUTTON_HEIGHT)																		
local RollMaster_number = RollMaster_TopButton:CreateFontString("RollMaster_number", nil, "GameFontNormal")
	RollMaster_number:SetText("|cffffff66#")
	RollMaster_number:SetPoint("LEFT", 5, 0)
local RollMaster_Name = RollMaster_TopButton:CreateFontString("RollMaster_name.", nil, "GameFontNormal")
	RollMaster_Name:SetPoint("LEFT", RollMaster_TopButton, "LEFT", 20, 0)
	RollMaster_Name:SetText("|cffffffff" .. L["Name"] .. ":")
local RollMaster_Roll = RollMaster_TopButton:CreateFontString("RollMaster_roll", nil, "GameFontNormal")
	RollMaster_Roll:SetPoint("RIGHT", RollMaster_TopButton, "RIGHT", -3, 0)
	RollMaster_Roll:SetText("|cffffffff" .. L["Roll"])
	RollMaster_ItemFrame:Hide()

	
--creator for the right buttons (item buttons)
local function createItemButtons()
	for i = 1, table.getn(itemsForRoll), 1 do
		local button = CreateFrame("Button", "RollMaster_ItemButton"..NUM_ITEMBUTTONS + 1, RollMaster_ItemFrame)
		RollMaster_ItemFrame:SetHeight((NUM_ITEMBUTTONS + 1) *BUTTON_HEIGHT + 20)
		if NUM_ITEMBUTTONS == 0 then
			button:SetPoint("TOP",  RollMaster_ItemFrame, "TOP", 0, -10)
			NUM_ITEMBUTTONS = NUM_ITEMBUTTONS + 1
		else
			button:SetPoint("TOP", itemButtons[NUM_ITEMBUTTONS], "BOTTOM")
			NUM_ITEMBUTTONS = NUM_ITEMBUTTONS + 1
		end
		button:SetSize(150, BUTTON_HEIGHT)
		button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
		button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
		button:Show()
		button:SetScript("OnClick", function()
														for i = 1, NUM_ITEMBUTTONS do
															itemButtons[i]:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
														end
														button:SetNormalTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
														local texture = select(10, GetItemInfo(itemsForRoll[i]))
														RollMaster_Item:SetNormalTexture(texture)
														nextItem = itemsForRoll[i]
														RollMaster_StartRollText:SetText("|cffffffff" .. L["Start Rolls!"])
													end)
		local item = button:CreateFontString("RollMaster_item"..i, nil, "GameFontNormal")
			item:SetText(itemsForRoll[i])
			item:SetPoint("CENTER")
		button:SetScript("OnEnter", function(self)
														if nextItem then
															GameTooltip:SetOwner(self)
															GameTooltip:SetPoint("LEFT", button, "RIGHT")
															GameTooltip:SetHyperlink(item:GetText())
															GameTooltip:Show()
														end
													end)
		button:SetScript("OnLeave",  function(self)
														GameTooltip:Hide()
													end)
		itemButtons[NUM_ITEMBUTTONS] = button
		items[NUM_ITEMBUTTONS] = item
	end
end
	
	
-- Function to be fired each time a lot is awarded to reset roll-data.
local function lootAwarded()
	for i = 1, NUM_ITEMBUTTONS do
		itemButtons[i]:ClearAllPoints()
		itemButtons[i]:Hide()
		if nextItem and nextItem == itemsForRoll[i] then
			table.remove(itemsForRoll, i)
		end
	end
	nextItem = nil
	RollMaster_Item:SetNormalTexture("Interface\\BUTTONS\\UI-EmptySlot")
	RollMaster_Award:Hide()
	RollMaster_StartRoll:Show()
	RollMaster_StartRollText:SetText("|cffffffff" .. L["Pick an Item!"])
	table.wipe(highestRoller)
	highestRoll = 0
	winner = nil
	NUM_ITEMBUTTONS = 0
	createItemButtons()
	--button_clear()
end


--"Award Loot!" Button
local RollMaster_Award = CreateFrame("Button", "RollMaster_Award", RollMaster_TopFrame)
	RollMaster_Award:SetPoint("TOP", RollMaster_StartRoll, "BOTTOM", 0, -5)
	RollMaster_Award:SetSize(80, 20)
	local RollMaster_AwardText = RollMaster_Award:CreateFontString("RollMaster_AwardText", nil, "GameFontNormal")
		RollMaster_AwardText:SetText("|cffffffff" .. L["Award Loot!"])
		RollMaster_AwardText:SetPoint("CENTER")
	RollMaster_Award:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_Award:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
	RollMaster_Award:SetScript("OnClick", function()
																		if nextItem and not rollStarted then
																			if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																				chatMethod = "RAID_WARNING"
																			elseif IsInRaid() then
																				chatMethod = "RAID"
																			else
																				chatMethod = "PARTY"
																			end
																			local name
																			local index
																			if table.getn(highestRoller) == 1 then	
																				for i = 1, GetNumLootItems() do
																					if nextItem == GetLootSlotLink(i) then
																						index = i
																					end
																				end
																				for i = 1, GetNumGroupMembers() do
																					if highestRoller[1] and highestRoller[1] == GetMasterLootCandidate(index, i) then
																						if nextItem and highestRoller[1] and chatMethod then
																							SendChatMessage(highestRoller[1] .. " " .. L["have won the rolls for"] .. " " .. nextItem .. "! " .. L["Congratulation!"], chatMethod)
																						end
																						GiveMasterLoot(index, i)
																						lootAwarded()
																					end
																				end
																			elseif table.getn(highestRoller) >= 1 then
																				d(L["Reroll required - 2 or more people at max roll"])
																			else
																				d(L["No one rolled."])
																			end																			
																		end
																	end)
	RollMaster_Award:Hide()

-- Creates the roll-buttons!
local function createButton(name, roll, minRoll, maxRoll)
	if name and maxRoll == "100" and minRoll == "1" then
		local button = CreateFrame("Button", "RollMaster_button"..NUM_BUTTONS + 1, RollMaster_RollFrame)
		RollMaster_RollFrame:SetHeight(BUTTON_HEIGHT * (NUM_BUTTONS + 1) + 25)
		RollMaster_RollFrame:Show()
		if NUM_BUTTONS == 0 then
			button:SetPoint("TOP", RollMaster_RollFrame, "TOP", 0, -20)
			NUM_BUTTONS = 1
		else
			button:SetPoint("TOP", buttons[NUM_BUTTONS], "BOTTOM")
			NUM_BUTTONS = NUM_BUTTONS + 1
		end
		button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
		button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
		button:SetSize(BUTTON_WIDTH, BUTTON_HEIGHT)
		
		local number = button:CreateFontString("RollMaster_number"..NUM_BUTTONS, nil, "GameFontNormal")
		number:SetText("|cffffffff[".. NUM_BUTTONS .."]")
		number:SetPoint("LEFT")
		
		local Name = button:CreateFontString("RollMaster_name."..NUM_BUTTONS, nil, "GameFontNormal")
		Name:SetPoint("LEFT", button, "LEFT", 20 + BUTTON_HEIGHT, 0)
		
		local roleTexture = button:CreateTexture()
		roleTexture:SetWidth(BUTTON_HEIGHT - 2)
		roleTexture:SetHeight(BUTTON_HEIGHT - 2)
		roleTexture:SetPoint("LEFT", button, "LEFT", 20, 0)

		local Roll = button:CreateFontString("RollMaster_roll"..NUM_BUTTONS, nil, "GameFontNormal")
		Roll:SetPoint("RIGHT", button, "RIGHT", -10, 0)
		button:Show()
		local highlight
		button:SetScript("OnClick", function() 
														if highlight then
															button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
															highlight = false
															winner = nil
														else
															for i = 1, NUM_BUTTONS do
																buttons[i]:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
															end
															button:SetNormalTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
															winner = Name:GetText()
															highlight = true
														end
													end)
		roleTextures[NUM_BUTTONS] = roleTexture
		buttons[NUM_BUTTONS] = button
		rolls[NUM_BUTTONS] = Roll
		names[NUM_BUTTONS] = Name
		
		local buttonCount = 1
		local role
		for i=100,1,-1 do
			if RollMaster_RollCollector[""..i..""] then
				for k,v in ipairs(RollMaster_RollCollector[""..i..""]) do
					if RollMaster_RollCollector[""..i..""] then
						local class
						local classColor
						for i = 1, GetNumGroupMembers() do
							if select(1, UnitName("PLAYER")) == v then
								class = select(2, UnitClass("PLAYER"))
								name = GetUnitName("PLAYER", true)
								role = UnitGroupRolesAssigned("PLAYER")
							elseif select(1, UnitName("party"..i)) == v then
								class = select(2, UnitClass("party"..i))
								name = GetUnitName("party"..i, true)
								role = UnitGroupRolesAssigned("party"..i)
							elseif UnitName("raid"..i) == v then
								class = select(2, UnitClass("raid"..i))
								name = GetUnitName("raid"..i, true)
								role = UnitGroupRolesAssigned("raid"..i)
							end
						end
						if class then
							classColor = (RAID_CLASS_COLORS[class].colorStr)
						else
							classColor = "FFFFFF00"
						end
						if classColor then
							names[buttonCount]:SetText("|c"..classColor..name)
							rolls[buttonCount]:SetText("|c"..classColor.. i)
						else
							names[buttonCount]:SetText(name)
							rolls[buttonCount]:SetText(i)
						end
						if role then
							if role == "TANK" then
								roleTextures[buttonCount]:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
								roleTextures[buttonCount]:SetTexCoord(0, 0.25, 0.25, 0.5)
							elseif role == "HEALER" then
								roleTextures[buttonCount]:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
								roleTextures[buttonCount]:SetTexCoord(0.25, 0.5, 0, 0.25)
							elseif role == "DAMAGER" then
								roleTextures[buttonCount]:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
								roleTextures[buttonCount]:SetTexCoord(0.25, 0.5, 0.25, 0.5)
							else
								roleTextures[buttonCount]:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
								roleTextures[buttonCount]:SetTexCoord(0, 0.25, 0.5, 0.75)								
							end
						end
						buttonCount = buttonCount + 1
					end
				end
			end
		end
	end
end

-- Shows the frame and sets the items to be distributed in queue!
function RollMaster:LOOT_OPENED()
	table.wipe(itemsForRoll)
	for i = 1, NUM_ITEMBUTTONS do
		itemButtons[i]:ClearAllPoints()
		itemButtons[i]:Hide()
	end
	NUM_ITEMBUTTONS = 0
	RollMaster_TopFrame:Hide()
	local lootMethod, masterLooter, _ = GetLootMethod()
	if lootMethod == "master" and masterLooter == 0 then
		for i = 1, 40 do
			local quantity
			local itemLink = GetLootSlotLink(i)
			if itemLink then
				quantity = select(3, GetItemInfo(itemLink))
			end
			if itemLink and quantity and quantity >= GetLootThreshold() then
				table.insert(itemsForRoll, itemLink)
				RollMaster_TopFrame:Show()
			end
			if buttons[i] then 
				buttons[i]:Show()
			end
		end
		RollMaster_ItemFrame:Show()
		if not nextItem then
			RollMaster_StartRollText:SetText("|cffffffff" .. L["Pick an Item!"])
		end
		
		createItemButtons()
	end
end

-- Hides shit...
function RollMaster:LOOT_CLOSED()
	table.wipe(itemsForRoll)
	for i = 1, NUM_ITEMBUTTONS do
		itemButtons[i]:ClearAllPoints()
		itemButtons[i]:Hide()
	end
	NUM_ITEMBUTTONS = 0
	RollMaster_TopFrame:Hide()
end

-- Roll handler function... It does.... handle the rolls!
function RollMaster:CHAT_MSG_SYSTEM(event, ...)
	local arg1 = select(1, ...)
	if arg1 then
		local name, roll, minRoll, maxRoll = arg1:match(L["^(.+) rolls (%d+) %((%d+)%-(%d+)%)$"])
		if name then
			local rollNum = tonumber(roll)
			local nameServer		
			for i = 1, GetNumGroupMembers() do
				if select(1, UnitName("PLAYER")) == name then
					nameServer = GetUnitName("PLAYER", true)
				elseif select(1, UnitName("party"..i)) == name then
					nameServer = GetUnitName("party"..i, true)
				elseif UnitName("raid"..i) == name then
					nameServer = GetUnitName("raid"..i, true)
				end
			end
			if alreadyRolled[name] then
				if IsInRaid() then
					SendChatMessage(nameServer .. " " .. L["rolled more then once. Second rolls will be ignored!"], "RAID")
				else
					SendChatMessage(L["nameServer rolled more then once. Second rolls will be ignored!"], "PARTY")
				end
				roll = nil
			else
				alreadyRolled[name] = true
			end	
			local index
			if nextItem then
				for i = 1, GetNumLootItems() do
					if nextItem == GetLootSlotLink(i) then
						index = i
					end
				end
			end
			if RollMaster_StartRollText:GetText() == "|cffffffff" .. L["Raid Roll!"] and name == select(1, UnitName("PLAYER")) then
				table.wipe(highestRoller)
				highestRoll = 0
				local name = GetMasterLootCandidate(index, rollNum)
				local minRoll, maxRoll = "1", "100"
				winner = name
				table.insert(highestRoller, 1, name)
				RollMaster_Award:Show()
				RollMaster_StartRoll:Hide()
				RollMaster_RollCollector[roll] = {}
				table.insert(RollMaster_RollCollector[roll], 1, name)
				createButton(name, roll, minRoll, maxRoll)
			elseif rollStarted then
				for i = 1, GetNumGroupMembers() do
					if GetNumLootItems() ~= 0 then					
						if name == GetMasterLootCandidate(index, i) then
							lootCandidates[name] = true 
						end
					end
				end
				if lootCandidates[name]  then
					if roll then
						if rollNum >= highestRoll then
							if rollNum ~= highestRoll then
								table.wipe(highestRoller)
								highestRoll = rollNum
							end
							table.insert(highestRoller, 1, nameServer)
						end					
						if RollMaster_RollCollector[roll]==nil then
							RollMaster_RollCollector[roll] = {} --more than one person can roll the same number that is why the table
						end
						if minRoll == "1" and maxRoll == "100" then
							table.insert(RollMaster_RollCollector[roll], 1, 0)
							RollMaster_RollCollector[roll][1] = name
						end
						createButton(name, roll, minRoll, maxRoll)
					end
				end
			end
		end
	end
end

-- Make sure the mainframe is hidden by default! (probably could have it earlier, but just in-case there's any leaks in the code, hide shit!
RollMaster_TopFrame:Hide()
